# Contributing
Nyxx is free and open-source project, and all contributions are welcome and highly appreciated.
However, please conform to the following guidelines when possible.

## Branches

Repo contains few main protected branches:
- `main` - for current stable version. Used for releasing new versions
- `dev` - for changes for next minor or patch version release
- `next` - for changes for next major version release

## Development cycle

All changes should be discussed beforehand either in issue or pull request on github
or in a discussion in our Discord channel with library regulars or other contributors.

All issues marked with 'help-needed' badge are free to be picked up by any member of the community.

### Pull Requests

Pull requests should be descriptive about changes that are made.
If adding new functionality or modifying existing, documentation should be added/modified to reflect changes.

## Coding style

We attempt to conform [Effective Dart Coding Style](https://dart.dev/guides/language/effective-dart/style) where possible.
However, code style rules are not enforcement and code should be readable and easy to maintain.

**One exception to rules above is line limit - we use 160 character line limit instead of 80 chars.**
